models/ContactForm.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * ContactForm is the model behind the contact form.
 */
class ContactForm extends Model
{
    public $name;
    public $email;
    public $subject;
    public $body;
    public $verifyCode;


    /**
     * @return array the validation rules.
     */
    public function rules()
    {
        return [
            // name, email, subject and body are required
            [['name', 'email', 'subject', 'body'], 'required'],
            // email has to be a valid email address
            ['email', 'email'],
            // verifyCode needs to be entered correctly
            ['verifyCode', 'captcha'],
        ];
    }

    /**
     * @return array customized attribute labels
     */
    public function attributeLabels()
    {
        return [
            'verifyCode' => 'Verification Code',
        ];
    }

    /**
     * Sends an email to the specified email address using the information collected by this model.
     * @param string $email the target email address
     * @return bool whether the model passes validation
     */
    public function contact($email)
    {
        if ($this->validate()) {
            Yii::$app->mailer->compose()
                ->setTo($email)
                ->setFrom([$this->email => $this->name])
                ->setSubject($this->subject)
                ->setTextBody($this->body)
                ->send();

            return true;
        }
        return false;
    }
}

models/LoginForm.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * LoginForm is the model behind the login form.
 *
 * @property User|null $user This property is read-only.
 *
 */
class LoginForm extends Model
{
    public $username;
    public $password;
    public $rememberMe = true;

    private $_user = false;


    /**
     * @return array the validation rules.
     */
    public function rules()
    {
        return [
            // username and password are both required
            [['username', 'password'], 'required'],
            // rememberMe must be a boolean value
            ['rememberMe', 'boolean'],
            // password is validated by validatePassword()
            ['password', 'validatePassword'],
        ];
    }

    /**
     * Validates the password.
     * This method serves as the inline validation for password.
     *
     * @param string $attribute the attribute currently being validated
     * @param array $params the additional name-value pairs given in the rule
     */
    public function validatePassword($attribute, $params)
    {
        if (!$this->hasErrors()) {
            $user = $this->getUser();

            if (!$user || !$user->validatePassword($this->password)) {
                $this->addError($attribute, 'Incorrect username or password.');
            }
        }
    }

    /**
     * Logs in a user using the provided username and password.
     * @return bool whether the user is logged in successfully
     */
    public function login()
    {
        if ($this->validate()) {
            return Yii::$app->user->login($this->getUser(), $this->rememberMe ? 3600*24*30 : 0);
        }
        return false;
    }

    /**
     * Finds user by [[username]]
     *
     * @return User|null
     */
    public function getUser()
    {
        if ($this->_user === false) {
            $this->_user = User::findByUsername($this->username);
        }

        return $this->_user;
    }
}

models/User.php
<?php

namespace app\models;

class User extends \yii\base\BaseObject implements \yii\web\IdentityInterface
{
    public $id;
    public $username;
    public $password;
    public $authKey;
    public $accessToken;

    private static $users = [
        '100' => [
            'id' => '100',
            'username' => 'admin',
            'password' => 'admin',
            'authKey' => 'test100key',
            'accessToken' => '100-token',
        ],
        '101' => [
            'id' => '101',
            'username' => 'demo',
            'password' => 'demo',
            'authKey' => 'test101key',
            'accessToken' => '101-token',
        ],
    ];


    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return isset(self::$users[$id]) ? new static(self::$users[$id]) : null;
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        foreach (self::$users as $user) {
            if ($user['accessToken'] === $token) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        foreach (self::$users as $user) {
            if (strcasecmp($user['username'], $username) === 0) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->authKey;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->authKey === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return $this->password === $password;
    }
}

models/usuarios.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

class Usuarios extends Model
{
    public $nombre;
    public $apellidos;
    public $edad;
    public $email;
    public function rules()
    {
        return [
            [['nombre', 'edad', 'email'], 'required','message'=>'{attribute} es obligatorio'],
            ['email', 'email','message'=>'Escribir correctamente el correo electrónico'],
            ['edad','number','min'=>18,'max'=>65,'tooBig'=>'La edad debe estar entre 18 y 65',
                'tooSmall'=>'La edad debe estar entre 18 y 65']
        ];
    }
    public function attributeLabels()
    {
        return [
            'nombre' => 'Nombre de usuario',
        ];
    }
   
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\Usuarios;
use app\components\Mensaje;

class SiteController extends Controller
{
    

    
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    
    public function actionPrueba()
    {
        $datos="<script>alert('Recibiendo datos...');</script>";
        
        return $this->render("vista",[
            "datos"=>$datos
        ]);
    }
    public function actionPrueba2()
    {
        $datos="<script>alert('1');</script>";
        
        return $this->render("vista2",[
            "datos"=>$datos
        ]);
    }
    public function actionFormulario()
    {
        if($datos=Yii::$app->request->post()){
            return $this->render("vista2",[
                "datos" => $datos["usuario"]
            ]);
        }else{
            return $this->render("formulario");
        }
    }
    public function actionUsuarios()
    {
        $model=new Usuarios();
        if($model->load(Yii::$app->request->post())){
            return $this->render('mostrarUsuarios', ['model' => $model]);
        }else{
            return $this->render('formularioUsuarios',['model'=>$model]);
        }
    }
    public function actionMensaje()
    {
        return $this->render("mensaje",[
            "titulo"=>'Ejemplo de clase',
            "texto"=>'Texto de ejemplo'
        ]);
    }
    public function actionMensaje1()
    {
        return $this->render("mensaje1",[
            "titulo"=>'Ejemplo de clase',
            "pie"=>'Pie'
        ]);
    }
    public function actionMensaje2()
    {
        return $this->render("mensaje2",[
            "titulo"=>'Ejemplo de clase',
            "contenido"=>'Texto de ejemplo'
        ]);
    }
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\widgets\Alert;
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\widgets\Breadcrumbs;
use app\assets\AppAsset;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?= Html::csrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
<?php $this->beginBody() ?>

<div class="wrap">
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar-inverse navbar-fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav navbar-right'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Prueba-1', 'url' => ['/site/prueba']],
            ['label' => 'Prueba-2', 'url' => ['/site/prueba2']],
            ['label' => 'Formulario' , 'url' => ['/site/formulario']],
            ['label' => 'Usuarios', 'url' => ['/site/usuarios']],
            ['label' => 'Mensajes','items'=>[
                ['label'=>'mensaje','url'=>['/site/mensaje']],
                ['label'=>'mensaje1','url'=>['/site/mensaje1']],
                ['label'=>'mensaje2','url'=>['/site/mensaje2']],
            ]]
            
        ],
    ]);
    NavBar::end();
    ?>

    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</div>

<footer class="footer">
    <div class="container">
        <p class="pull-left">Hoja de ejercicios 3</p>

        <p class="pull-right">Alpe Formación</p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        Upss.....
    </p>
    <p>
        Hay un problema
    </p>

</div>

views/site/formulario.php
<?php

use yii\helpers\Html;

echo Html::beginForm(['site/formulario'], 'post');
echo Html::beginTag('div', ['class' => 'form-group']);
echo Html::label('Nombre', 'usuario', ['class' => 'control-label']);
echo Html::input('text', 'usuario','',['id' =>'usuario','class'=>'form-control']);
echo Html::endTag('div');
echo Html::submitButton('Enviar',['class' => 'btn btn-info']);
echo Html::endForm();

views/site/formularioUsuarios.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

?>

<?php $form = ActiveForm::begin(); ?>

<?= $form->field($model, 'nombre') ?>
<?= $form->field($model, 'apellidos') ?>
<?= $form->field($model, 'email') ?>
<?= $form->field($model, 'edad') ?>

<div class="form-group">
<?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
</div>

<?php ActiveForm::end(); ?>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Probando elementos Yii.</h1>

        <p class="lead">Hoja de ejercicios 3</p>

        
    </div>

    
</div>

views/site/mensaje.php
<?php

use app\components\Mensaje;

echo Mensaje::widget([
    "titulo"=>$titulo,
    "texto"=>$texto
]);

views/site/mensaje1.php
<?php

use app\components\Mensaje1;

Mensaje1::begin([
    'titulo'=>$titulo,
    'pie'=>$pie
]);
?>

Esto es un ejemplo de clase
<?php 
    Mensaje1::end();

views/site/mensaje2.php
<?php

use app\components\Mensaje2;

echo Mensaje2::widget([
    "titulo"=>$titulo,
    "contenido"=>$contenido
]);

views/site/mostrarUsuarios.php
<?php

use yii\helpers\Html;
?>

<p>Has introducido la siguiente informacion</p>
<ul>
    <li><label>Nombre</label>: <?= Html::encode($model->nombre) ?></li>
    <li><label>Apellidos</label>: <?= Html::encode($model->apellidos) ?></li>
    <li><label>Edad</label>: <?= Html::encode($model->edad) ?></li>
    <li><label>Email</label>: <?= Html::encode($model->email) ?></li>
</ul>

views/site/vista.php
<?php


echo yii\helpers\Html::encode($datos);
echo $datos;
?>

views/site/vista2.php
<?php

echo $datos;
?>

views/usuarios/index.php
<?php
/* @var $this yii\web\View */
?>
<h1>usuarios/index</h1>

<p>
    You may change the content of this page by modifying
    the file <code><?= __FILE__; ?></code>.
</p>